---
title: Create web or API operations
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/typescript)

[API Gateway](https://developers.cloudflare.com/api/typescript/resources/api_gateway)

[Operations](https://developers.cloudflare.com/api/typescript/resources/api_gateway/subresources/operations)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create web or API operations

client.apiGateway.operations.bulkCreate(OperationBulkCreateParams {zone\_id, body } params, RequestOptionsoptions?): SinglePage< [OperationBulkCreateResponse](<https://developers.cloudflare.com/api/typescript/resources/api_gateway#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)>) {endpoint, host, last\_updated, 3 more } >

POST/zones/{zone\_id}/api\_gateway/operations

Creates one or more web or API operations. Hosts, methods, and paths are normalized; an existing matching operation is returned instead of duplicated.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account API Gateway``Domain API Gateway`

##### ParametersExpand Collapse

<details>

<summary>

params: OperationBulkCreateParams {zone\_id, body }

</summary>

zone\_id: string

Path param: Identifier.

maxLength32

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

<details>

<summary>

body: Array&lt;Body&gt;

Body param

</summary>

endpoint: string

The endpoint which can contain path parameter templates in curly braces, each will be replaced from left to right with {varN}, starting with {var1}, during insertion. This will further be Cloudflare-normalized upon insertion. See: <a href="https://developers.cloudflare.com/rules/normalization/how-it-works/">https://developers.cloudflare.com/rules/normalization/how-it-works/</a>.

formaturi-template

maxLength4096

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20endpoint">Link to this property</a>

host: string

RFC3986-compliant host.

formathostname

maxLength255

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20host">Link to this property</a>

<details>

<summary>

method: "GET"| "POST"| "HEAD"| 6 more

The HTTP method used to access the endpoint.

</summary>

One of the following:

"GET"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%200">Link to this property</a>

"POST"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%201">Link to this property</a>

"HEAD"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%202">Link to this property</a>

"OPTIONS"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%203">Link to this property</a>

"PUT"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%204">Link to this property</a>

"DELETE"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%205">Link to this property</a>

"CONNECT"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%206">Link to this property</a>

"PATCH"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%207">Link to this property</a>

"TRACE"

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method%20%3E%20(member)%208">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20method">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default%20%3E%20(param)%20body">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.operations%20%3E%20(method)%20bulk_create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

OperationBulkCreateResponse {endpoint, host, last\_updated, 3 more }

</summary>

endpoint: string

The endpoint which can contain path parameter templates in curly braces, each will be replaced from left to right with {varN}, starting with {var1}, during insertion. This will further be Cloudflare-normalized upon insertion. See: <a href="https://developers.cloudflare.com/rules/normalization/how-it-works/">https://developers.cloudflare.com/rules/normalization/how-it-works/</a>.

formaturi-template

maxLength4096

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20endpoint">Link to this property</a>

host: string

RFC3986-compliant host.

formathostname

maxLength255

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20host">Link to this property</a>

last\_updated: string

formatdate-time

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20last_updated">Link to this property</a>

<details>

<summary>

method: "GET"| "POST"| "HEAD"| 6 more

The HTTP method used to access the endpoint.

</summary>

One of the following:

"GET"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%200">Link to this property</a>

"POST"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%201">Link to this property</a>

"HEAD"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%202">Link to this property</a>

"OPTIONS"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%203">Link to this property</a>

"PUT"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%204">Link to this property</a>

"DELETE"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%205">Link to this property</a>

"CONNECT"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%206">Link to this property</a>

"PATCH"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%207">Link to this property</a>

"TRACE"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method%20%3E%20(member)%208">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20method">Link to this property</a>

operation\_id: string

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20operation_id">Link to this property</a>

<details>

<summary>

features?: APIShieldOperationFeatureThresholds {thresholds } | APIShieldOperationFeatureParameterSchemas {parameter\_schemas } | APIShieldOperationFeatureAPIRouting {api\_routing } | 2 more

</summary>

One of the following:

<details>

<summary>

APIShieldOperationFeatureThresholds {thresholds }

</summary>

<details>

<summary>

thresholds?: Thresholds {auth\_id\_tokens, data\_points, last\_updated, 6 more }

</summary>

auth\_id\_tokens?: number

The total number of auth-ids seen across this calculation.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20auth_id_tokens">Link to this property</a>

data\_points?: number

The number of data points used for the threshold suggestion calculation.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20data_points">Link to this property</a>

last\_updated?: string

formatdate-time

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20last_updated">Link to this property</a>

p50?: number

The p50 quantile of requests (in period\_seconds).

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20p50">Link to this property</a>

p90?: number

The p90 quantile of requests (in period\_seconds).

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20p90">Link to this property</a>

p99?: number

The p99 quantile of requests (in period\_seconds).

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20p99">Link to this property</a>

period\_seconds?: number

The period over which this threshold is suggested.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20period_seconds">Link to this property</a>

requests?: number

The estimated number of requests covered by these calculations.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20requests">Link to this property</a>

suggested\_threshold?: number

The suggested threshold in requests done by the same auth\_id or period\_seconds.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20suggested_threshold">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%200">Link to this property</a>

<details>

<summary>

APIShieldOperationFeatureParameterSchemas {parameter\_schemas }

</summary>

<details>

<summary>

parameter\_schemas: ParameterSchemas {last\_updated, parameter\_schemas }

</summary>

last\_updated?: string

formatdate-time

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20last_updated">Link to this property</a>

<details>

<summary>

parameter\_schemas?: ParameterSchemas {parameters, responses }

An operation schema object containing a response.

</summary>

parameters?: Array&lt;unknown&gt;

An array containing the learned parameter schemas.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20parameters">Link to this property</a>

responses?: unknown

An empty response object. This field is required to yield a valid operation schema.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20responses">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20parameter_schemas">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%201">Link to this property</a>

<details>

<summary>

APIShieldOperationFeatureAPIRouting {api\_routing }

</summary>

<details>

<summary>

api\_routing?: APIRouting {last\_updated, route }

API Routing settings on endpoint.

</summary>

last\_updated?: string

formatdate-time

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%202%20%3E%20(property)%20api_routing%20%3E%20(property)%20last_updated">Link to this property</a>

route?: string

Target route.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%202%20%3E%20(property)%20api_routing%20%3E%20(property)%20route">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%202%20%3E%20(property)%20api_routing">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%202">Link to this property</a>

<details>

<summary>

APIShieldOperationFeatureConfidenceIntervals {confidence\_intervals }

</summary>

<details>

<summary>

confidence\_intervals?: ConfidenceIntervals {last\_updated, suggested\_threshold }

</summary>

last\_updated?: string

formatdate-time

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20last_updated">Link to this property</a>

<details>

<summary>

suggested\_threshold?: SuggestedThreshold {confidence\_intervals, mean }

</summary>

<details>

<summary>

confidence\_intervals?: ConfidenceIntervals {p90, p95, p99 }

</summary>

<details>

<summary>

p90?: P90 {lower, upper }

Upper and lower bound for percentile estimate

</summary>

lower?: number

Lower bound for percentile estimate

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p90%20%3E%20(property)%20lower">Link to this property</a>

upper?: number

Upper bound for percentile estimate

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p90%20%3E%20(property)%20upper">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p90">Link to this property</a>

<details>

<summary>

p95?: P95 {lower, upper }

Upper and lower bound for percentile estimate

</summary>

lower?: number

Lower bound for percentile estimate

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p95%20%3E%20(property)%20lower">Link to this property</a>

upper?: number

Upper bound for percentile estimate

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p95%20%3E%20(property)%20upper">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p95">Link to this property</a>

<details>

<summary>

p99?: P99 {lower, upper }

Upper and lower bound for percentile estimate

</summary>

lower?: number

Lower bound for percentile estimate

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p99%20%3E%20(property)%20lower">Link to this property</a>

upper?: number

Upper bound for percentile estimate

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p99%20%3E%20(property)%20upper">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p99">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals">Link to this property</a>

mean?: number

Suggested threshold.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20mean">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%203">Link to this property</a>

<details>

<summary>

APIShieldOperationFeatureSchemaInfo {schema\_info }

</summary>

<details>

<summary>

schema\_info?: SchemaInfo {active\_schema, mitigation\_action }

</summary>

<details>

<summary>

active\_schema?: ActiveSchema {id, created\_at, name }

Schema active on endpoint.

</summary>

id?: string

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20active_schema%20%3E%20(property)%20id">Link to this property</a>

created\_at?: string

formatdate-time

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20active_schema%20%3E%20(property)%20created_at">Link to this property</a>

name?: string

Schema file name.

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20active_schema%20%3E%20(property)%20name">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20active_schema">Link to this property</a>

<details>

<summary>

mitigation\_action?: "none"| "log"| "block"| null

Action taken on requests failing validation.

</summary>

One of the following:

"none"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20mitigation_action%20%3E%20(member)%200">Link to this property</a>

"log"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20mitigation_action%20%3E%20(member)%201">Link to this property</a>

"block"

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20mitigation_action%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20mitigation_action">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features%20%3E%20(variant)%204">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)%20%3E%20(property)%20features">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.operations%20%3E%20(model)%20operation_bulk_create_response%20%3E%20(schema)>)

### Create web or API operations

TypeScript

HTTPTypeScriptPythonGoTerraform

```
import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

// Automatically fetches more pages as needed.
for await (const operationBulkCreateResponse of client.apiGateway.operations.bulkCreate({
  zone_id: '023e105f4ecef8ad9ca31a8372d0c353',
  body: [
    {
      endpoint: '/api/v1/users/{var1}',
      host: 'www.example.com',
      method: 'GET',
    },
  ],
})) {
  console.log(operationBulkCreateResponse.operation_id);
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "endpoint": "/api/v1/users/{var1}",
      "host": "www.example.com",
      "last_updated": "2014-01-01T05:20:00.12345Z",
      "method": "GET",
      "operation_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
      "features": {
        "api_routing": {
          "last_updated": "2014-01-01T05:20:00.12345Z",
          "route": "https://api.example.com/api/service"
        }
      }
    }
  ],
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "endpoint": "/api/v1/users/{var1}",
      "host": "www.example.com",
      "last_updated": "2014-01-01T05:20:00.12345Z",
      "method": "GET",
      "operation_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
      "features": {
        "api_routing": {
          "last_updated": "2014-01-01T05:20:00.12345Z",
          "route": "https://api.example.com/api/service"
        }
      }
    }
  ],
  "success": true
}
```